<?php 
/**
 * READ THE README! That's where all the answers to all your questions are!
 * 
 * Released under a Creative Commons License: Attribution, Share Alike
 * http://creativecommons.org/licenses/by-sa/3.0/us/ where "attribution" means
 * keep my name and website URL in any derivative product you create from this
 * 
 * I'm EdB {@link http://wonderwinds.com/} and I approve this message
 */
if( !defined('EVO_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

/* This plugin has class! ------------------------------------------------------------------------------------------- */
class widgetmanager_plugin extends Plugin {
	var $apply_rendering = 'never';
	var $author = 'EdB';
	var $code = 'widgetmanager';
	var $group = 'other';
	var $help_url = 'http://wonderwinds.com/hackblog.php';
	var $long_desc = 'Widget Manager helps manage widgets by enabling copying widgets from one blog to any and all other blogs.';
	var $name = 'Widget Manager';
	var $number_of_installs = 1;
	var $priority = 99;
	var $short_desc = 'Widget Manager manages your widgets.';
	var $sub_group = '';
	var $version = '2.4.8.16';
	// vars unique to this plugin
	var $extra_info = '';

/* Init the Plugin after it has been registered/instantiated -------------------------------------------------------- */
function PluginInit( & $params ) {
	$this->name = $this->T_('Widget Manager');
	$this->short_desc = $this->T_('Widget Manager manages your widgets.');
	$this->long_desc = $this->T_('Widget Manager helps manage widgets by enabling copying widgets from one blog to any and all other blogs.');
	}

/* Define default settings that can then be edited in the backoffice ------------------------------------------------ */
function GetDefaultSettings( & $params ) {
	$default_settings = array(
		'master_blog' => array(
			'label' => $this->T_('Master Blog'),
			'type' => 'text',
			'defaultvalue' => '1',
			'note' => $this->T_('The blog you will use as the source blog for copying widgets.'),
			),
		'candostuff' => array(
			'label' => $this->T_('Can Do Stuff'),
			'type' => 'select',
			'defaultvalue' => 'admin_only',
			'options' => array( 
				'admin_only' => $this->T_('Only The Admin'), 
				'admin_group' => $this->T_('The Admin Group'), 
				'level_five' => $this->T_('Level 5 Members'), 
				'anyone' => $this->T_('Anyone') 
				),
			'note' => $this->T_('Who gets to run the widget manager?'),
			),
		);
	return $default_settings;
	}

/* Gets invoked in /admin.php for every backoffice page after the menu structure is built --------------------------- */
function AdminAfterMenuInit() {
	$this->register_menu_entry( $this->T_('Widgets') );
	}

/* Method that gets invoked when our tab is selected ---------------------------------------------------------------- */
function AdminTabAction() {
	global $DB, $tableprefix;
	$widget_table = $tableprefix.'widget';
	$master_blog = $this->Settings->get('master_blog');
	$this->extra_info = '';

	// this shows all widgets in all blogs
	if( param($this->get_class_id('what')) == 'showme' ) { 
		$showme = param( $this->get_class_id('showme') );
		if( $showme == '' ) {
			$this->msg( $this->T_('You can\'t show widgets from nothing!'), 'error' );
			return;
			}
		if( $showme == 'All' ) {
			global $Blog, $BlogCache;
			$blog_array = $BlogCache->load_public( 'ID' );
			$showme_rebuild = '';
			foreach( $blog_array as $l_blog_ID ) {
				if( $l_blog_ID != $master_blog ) {
					if( $showme_rebuild == '' ) {
						$showme_rebuild = $l_blog_ID;
						} else {
						$showme_rebuild .= ','.$l_blog_ID;
						}
					}
				}
			$showme = $showme_rebuild;
			}
		if( ! preg_match( '#^[,0-9]+$#', $showme ) ) {
			$this->msg( $this->T_('Only numbers and commas (or the word "All") are allowed in the "SHOW ME" field!'), 'error' );
			return;
			}
		$this->extra_info = $showme;
		}

	// this copies all widgets in the master to others
	if( param($this->get_class_id('what')) == 'copyto' ) { 
		$copyto = param( $this->get_class_id('copyto') );
		if( $copyto == '' ) {
			$this->msg( $this->T_('You can\'t copy widgets to nothing!'), 'error' );
			return;
			}
		if( $copyto == 'All' ) {
			global $Blog, $BlogCache;
			$blog_array = $BlogCache->load_public( 'ID' );
			$copyto_rebuild = '';
			foreach( $blog_array as $l_blog_ID ) {
				if( $l_blog_ID != $master_blog ) {
					if( $copyto_rebuild == '' ) {
						$copyto_rebuild = $l_blog_ID;
						} else {
						$copyto_rebuild .= ','.$l_blog_ID;
						}
					}
				}
			$copyto = $copyto_rebuild;
			}
		if( ! preg_match( '#^[,0-9]+$#', $copyto ) ) {
			$this->msg( $this->T_('Only numbers and commas (or the word "All") are allowed in the "COPY TO" field!'), 'error' );
			return;
			}
		$this->extra_info = $copyto;
		$copy_blogs = explode( ',', $copyto );
		foreach( $copy_blogs as $a_blog ) {
			settype( $a_blog, "integer" );
			$query = "DELETE FROM ".$widget_table." WHERE `wi_coll_ID` =$a_blog";
			$delete_widgets = $DB->query( $query );
			if( $delete_widgets === false ) {
				$this->msg( $this->T_('There was a problem deleting the widgets from the target blog. Actions NOT performed!'), 'error' );
				return;
				}
			$current_container = '';
			$inserted_widgets = 0;
			$widget_list = $DB->get_results("SELECT * FROM ".$widget_table." WHERE `wi_coll_ID` =$master_blog ORDER BY `wi_sco_name` ASC, `wi_order` ASC");
			foreach( $widget_list as $widget ) {
				if( $widget->wi_sco_name == $current_container ) {
					$widget_order = $widget_order+1;
					} else {
					$widget_order = 1;
					}
				$current_container = $widget->wi_sco_name;
				$query = 'INSERT INTO '.$widget_table.' (wi_coll_ID, wi_sco_name, wi_order, wi_type, wi_code, wi_params) VALUES ( \''.$DB->escape( $a_blog ).'\', \''.$DB->escape( $widget->wi_sco_name ).'\', \''.$DB->escape( $widget_order ).'\', \''.$DB->escape( $widget->wi_type ).'\', \''.$DB->escape( $widget->wi_code ).'\', \''.$DB->escape( $widget->wi_params ).'\' )';
				$insert_widget = $DB->query( $query );
				if( $insert_widget ) {
					$inserted_widgets = $inserted_widgets+1;
					}
				}
			$this->msg( $this->T_('Inserted').' '.$inserted_widgets.' '.$this->T_('widgets into blog #').' '.$a_blog.'!', 'success' );
			}
		}

	// this copies all widgets in one container from the master to others
	if( param($this->get_class_id('what')) == 'copycon' ) { 
		$copycon = param( $this->get_class_id('copycon') );
		$whichcon = param( $this->get_class_id('which') );
		if( $copycon == '' ) {
			$this->msg( $this->T_('You can\'t copy widgets in a container to nothing!'), 'error' );
			return;
			}
		if( $copycon == 'All' ) {
			global $Blog, $BlogCache;
			$blog_array = $BlogCache->load_public( 'ID' );
			$copycon_rebuild = '';
			foreach( $blog_array as $l_blog_ID ) {
				if( $l_blog_ID != $master_blog ) {
					if( $copycon_rebuild == '' ) {
						$copycon_rebuild = $l_blog_ID;
						} else {
						$copycon_rebuild .= ','.$l_blog_ID;
						}
					}
				}
			$copycon = $copycon_rebuild;
			}
		if( ! preg_match( '#^[,0-9]+$#', $copycon ) ) {
			$this->msg( $this->T_('Only numbers and commas (or the word "All") are allowed in the "COPY TO" field!'), 'error' );
			return;
			}
		$this->extra_info = $copycon;
		$copy_blogs = explode( ',', $copycon );
		foreach( $copy_blogs as $a_blog ) {
			settype( $a_blog, "integer" );
			$query = "DELETE FROM ".$widget_table." WHERE `wi_coll_ID` =$a_blog AND `wi_sco_name` = '{$whichcon}'";
			$delete_widgets = $DB->query( $query );
			if( $delete_widgets === false ) {
				$this->msg( $this->T_('There was a problem deleting the widgets from the target blog. Actions NOT performed!'), 'error' );
				return;
				}
			$current_container = '';
			$inserted_widgets = 0;
			$widget_list = $DB->get_results("SELECT * FROM ".$widget_table." WHERE `wi_coll_ID` =$master_blog AND `wi_sco_name` = '{$whichcon}' ORDER BY `wi_order` ASC");
			foreach( $widget_list as $widget ) {
				if( $widget->wi_sco_name == $current_container ) {
					$widget_order = $widget_order+1;
					} else {
					$widget_order = 1;
					}
				$current_container = $widget->wi_sco_name;
				$query = 'INSERT INTO '.$widget_table.' (wi_coll_ID, wi_sco_name, wi_order, wi_type, wi_code, wi_params) VALUES ( \''.$DB->escape( $a_blog ).'\', \''.$DB->escape( $widget->wi_sco_name ).'\', \''.$DB->escape( $widget_order ).'\', \''.$DB->escape( $widget->wi_type ).'\', \''.$DB->escape( $widget->wi_code ).'\', \''.$DB->escape( $widget->wi_params ).'\' )';
				$insert_widget = $DB->query( $query );
				if( $insert_widget ) {
					$inserted_widgets = $inserted_widgets+1;
					}
				}
			$this->msg( $this->T_('Inserted').' '.$inserted_widgets.' '.$this->T_('widgets into blog #').' '.$a_blog.'!', 'success' );
			}
		}

	// this copies one widget in the master to others
	if( param($this->get_class_id('what')) == 'copywidg' ) { 
		$copywidg = param( $this->get_class_id('copywidg') );
		$whichwidg = param( $this->get_class_id('which') );
		if( $copywidg == '' ) {
			$this->msg( $this->T_('You can\'t copy widgets in a container to nothing!'), 'error' );
			return;
			}
		if( $copywidg == 'All' ) {
			global $Blog, $BlogCache;
			$blog_array = $BlogCache->load_public( 'ID' );
			$copywidg_rebuild = '';
			foreach( $blog_array as $l_blog_ID ) {
				if( $l_blog_ID != $master_blog ) {
					if( $copywidg_rebuild == '' ) {
						$copywidg_rebuild = $l_blog_ID;
						} else {
						$copywidg_rebuild .= ','.$l_blog_ID;
						}
					}
				}
			$copywidg = $copywidg_rebuild;
			}
		if( ! preg_match( '#^[,0-9]+$#', $copywidg ) ) {
			$this->msg( $this->T_('Only numbers and commas (or the word "All") are allowed in the "COPY TO" field!'), 'error' );
			return;
			}
		$this->extra_info = $copywidg;
		$copy_blogs = explode( ',', $copywidg );
		foreach( $copy_blogs as $a_blog ) {
			settype( $a_blog, "integer" );
			$whichwidgarr = explode( '^', $whichwidg );
			$widget_list = $DB->get_results("SELECT * FROM ".$widget_table." WHERE `wi_coll_ID` =$master_blog AND `wi_sco_name` = '{$whichwidgarr[0]}' AND `wi_code` = '{$whichwidgarr[1]}' ORDER BY `wi_order` ASC");
			foreach( $widget_list as $widget ) {
				$query = "SELECT * FROM ".$widget_table." WHERE `wi_coll_ID` =$a_blog AND `wi_sco_name` = '{$whichwidgarr[0]}' AND `wi_code` = '{$whichwidgarr[1]}'";
				$find_matches = $DB->query( $query );
				if( $find_matches ) {
					$widget_order = $find_matches->widget_order;
					$query = "DELETE FROM ".$widget_table." WHERE `wi_coll_ID` =$a_blog AND `wi_sco_name` = '{$whichwidgarr[0]}' AND `wi_code` = '{$whichwidgarr[1]}'";
					$deleted_widget = $DB->query( $query );
					if( $deleted_widget === false ) {
						$this->msg( $this->T_('There was a problem deleting the widgets from the target blog. Actions NOT performed!'), 'error' );
						return;
						}
					$query = 'INSERT INTO '.$widget_table.' (wi_coll_ID, wi_sco_name, wi_order, wi_type, wi_code, wi_params) VALUES ( \''.$DB->escape( $a_blog ).'\', \''.$DB->escape( $widget->wi_sco_name ).'\', \''.$DB->escape( $widget_order ).'\', \''.$DB->escape( $widget->wi_type ).'\', \''.$DB->escape( $widget->wi_code ).'\', \''.$DB->escape( $widget->wi_params ).'\' )';
					$insert_widget = $DB->query( $query );
					if( $insert_widget ) {
						$this->msg( $this->T_('Inserted the widget into blog #').' '.$a_blog.'!', 'success' );
						}
					} else {
					$widget_order = 0;
					$current_widgets = $DB->get_results("SELECT * FROM ".$widget_table." WHERE `wi_coll_ID` =$a_blog AND `wi_sco_name` = '{$whichwidgarr[0]}'");
					foreach( $current_widgets as $current_widget ) {
						$widget_order = $widget_order+1;
						}
					$widget_order = $widget_order+1;
					$query = 'INSERT INTO '.$widget_table.' (wi_coll_ID, wi_sco_name, wi_order, wi_type, wi_code, wi_params) VALUES ( \''.$DB->escape( $a_blog ).'\', \''.$DB->escape( $widget->wi_sco_name ).'\', \''.$DB->escape( $widget_order ).'\', \''.$DB->escape( $widget->wi_type ).'\', \''.$DB->escape( $widget->wi_code ).'\', \''.$DB->escape( $widget->wi_params ).'\' )';
					$insert_widget = $DB->query( $query );
					if( $insert_widget ) {
						$this->msg( $this->T_('Inserted the widget into blog #').' '.$a_blog.'!', 'success' );
						}
					}
				}
			}
		}

	// this rebuilds the widgets table
	if( param($this->get_class_id('what')) == 'rebuild' ) { 
		$full_widget_list = $DB->get_results("SELECT * FROM ".$widget_table." ORDER BY `wi_coll_ID` ASC, `wi_sco_name` ASC, `wi_order` ASC");
		$query = "DELETE FROM ".$widget_table." WHERE 1";
		$delete_all_widgets = $DB->query( $query );
		$query = "ALTER TABLE ".$widget_table." AUTO_INCREMENT =1";
		$reset_autoinc = $DB->query( $query );
		$current_blog = '';
		$current_container = '';
		$inserted_widgets = 0;
		foreach( $full_widget_list as $a_widget ) {
			if( $a_widget->wi_coll_ID == $current_blog ) {
				if( $a_widget->wi_sco_name == $current_container ) {
					$widget_order = $widget_order+1;
					} else {
					$widget_order = 1;
					}
				$current_container = $a_widget->wi_sco_name;
				} else { 
				$current_blog = $a_widget->wi_coll_ID;
				$current_container = $a_widget->wi_sco_name;
				$widget_order = 1;
				if( $this->extra_info == '' ) {
					$this->extra_info = $this->extra_info.$current_blog;
					} else {
					$this->extra_info = $this->extra_info.','.$current_blog;
					}
				}
			$query = 'INSERT INTO '.$widget_table.' (wi_coll_ID, wi_sco_name, wi_order, wi_type, wi_code, wi_params) VALUES ( \''.$DB->escape( $a_widget->wi_coll_ID ).'\', \''.$DB->escape( $a_widget->wi_sco_name ).'\', \''.$DB->escape( $widget_order ).'\', \''.$DB->escape( $a_widget->wi_type ).'\', \''.$DB->escape( $a_widget->wi_code ).'\', \''.$DB->escape( $a_widget->wi_params ).'\' )';
			$insert_widget = $DB->query( $query );
			if( $insert_widget ) {
				$inserted_widgets = $inserted_widgets+1;
				}
			}
		} 
	}

/* Gets invoked when our tab is selected and should get displayed --------------------------------------------------- */
function AdminTabPayload() {
	global $DB, $current_User, $tableprefix;
	$candostuff = $this->Settings->get( 'candostuff' );
	$can_do_stuff = false;
	switch( $candostuff ) {
		case 'admin_only':
		if( $current_User->ID == 1 ) {$can_do_stuff = true;}
		break;
		case 'admin_group':
		if( ($current_User->ID == 1) || ($current_User->Group->ID == 1) ) {$can_do_stuff = true;}
		break;
		case 'level_five':
		if( ($current_User->ID == 1) || ($current_User->level >= 5) ) {$can_do_stuff = true;}
		break;
		case 'anyone':
		$can_do_stuff = true;
		break;
		}

	// return if not authorized to do stuff
	if( ! $can_do_stuff ) {
		return;
		}

	// build the display table
	$widget_table = $tableprefix.'widget';
	$master_blog = $this->Settings->get('master_blog');
	echo '<h2>'.$this->T_('The Master Blog Widgets <em>(blog #').$master_blog.'</em>):</h2>'; ?>
	<table class="grouped" cellspacing="0"><thead><tr>
	<?php 
	echo '<th>'.$this->T_('Container (order)').':</th>';
	echo '<th>'.$this->T_('Widget name').':</th>';
	echo '<th>'.$this->T_('Widget type').':</th>';
	echo '<th>'.$this->T_('Widget table #').':</th>'; ?>
	</tr></thead><tbody>
	<?php 
	$count = 0;
	$current_sco_name = '';
	$master_containers = '';
	$master_widget_list = array();
	$widget_list = $DB->get_results("SELECT * FROM ".$widget_table." WHERE `wi_coll_ID` =$master_blog ORDER BY `wi_sco_name` ASC, `wi_order` ASC");
	foreach( $widget_list as $widget ) { ?>
		<tr <?php if($count%2 == 1) echo 'class="odd"' ?>>
		<td class="firstcol">
		<?php 
		if( $widget->wi_sco_name != $current_sco_name ) {
			echo '<strong>'.$widget->wi_sco_name.'</strong> ('. $widget->wi_order.')</td>'."\n";
			if( $master_containers == '' ) {
				$master_containers = $widget->wi_sco_name;
				} else {
				$master_containers = $master_containers.','.$widget->wi_sco_name;
				}
			} else {
			echo '&nbsp;&nbsp;&nbsp;&nbsp;<em>'.$widget->wi_sco_name.'</em> ('. $widget->wi_order.')</td>'."\n";
			}
		$current_sco_name = $widget->wi_sco_name;
		echo '<td>'.$widget->wi_code.'</td>'."\n";
		echo '<td>'.$widget->wi_type.'</td>'."\n";
		echo '<td>'.$widget->wi_ID.'</td>'."\n";
		echo '</tr>'."\n";
		$count++;
		$master_widget_list[] = array( $widget->wi_sco_name, $widget->wi_code, $widget->wi_order );
		}
	echo '</tbody></table>'."\n";
	echo '<p>Change the "Master Blog" on your plugins settings page (use the "pencil on paper" link at upper right).</p>'."\n";
	if( $this->extra_info != '' ) {
		$other_blogs = explode( ',', $this->extra_info );
		foreach( $other_blogs as $a_blog ) {
			settype( $a_blog, "integer" );
			echo '<div style="background-color:#FFFFCC;border:1px solid red;padding-left:2em;">'.$this->T_('Widgets for blog #').$a_blog.':</div>'; ?>
			<table class="grouped" cellspacing="0"><thead><tr>
			<?php 
			echo '<th>'.$this->T_('Container (order)').':</th>';
			echo '<th>'.$this->T_('Widget name').':</th>';
			echo '<th>'.$this->T_('Widget type').':</th>';
			echo '<th>'.$this->T_('Widget table entry #').':</th>'; ?>
			</tr></thead><tbody>
			<?php 
			$count = 0;
			$current_sco_name = '';
			$widget_list = $DB->get_results("SELECT * FROM ".$widget_table." WHERE `wi_coll_ID` =$a_blog ORDER BY `wi_sco_name` ASC, `wi_order` ASC");
			foreach( $widget_list as $widget ) { ?>
				<tr <?php if($count%2 == 1) echo 'class="odd"' ?>>
				<td class="firstcol">
				<?php 
				if( $widget->wi_sco_name != $current_sco_name ) {
					echo '<strong>'.$widget->wi_sco_name.'</strong> ('. $widget->wi_order.')</td>'."\n";
					} else {
					echo '&nbsp;&nbsp;&nbsp;&nbsp;<em>'.$widget->wi_sco_name.'</em> ('. $widget->wi_order.')</td>'."\n";
					}
				$current_sco_name = $widget->wi_sco_name;
				echo '<td>'.$widget->wi_code.'</td>'."\n";
				echo '<td>'.$widget->wi_type.'</td>'."\n";
				echo '<td>'.$widget->wi_ID.'</td>'."\n";
				echo '</tr>'."\n";
				$count++;
				}
			echo '</tbody></table>'."\n";
			}
		}

	// show widgets form
	$Form = & new Form( NULL, 'widget_manager', 'post', 'compact' );
	$Form->begin_form( 'fform', $this->T_('Show Widgets') );
	$Form->hidden_ctrl();
	$Form->hiddens_by_key( get_memorized() );
	echo '<p>Enter the blog IDs you want to SEE widgets for.</p>';
	$Form->hidden( $this->get_class_id().'_what', 'showme' );
	$Form->text_input( $this->get_class_id().'_showme', '', '40', $this->T_('SHOW ME'), $this->T_('Use a comma-separated list (3,8,12) or the word "All"'), array( 'maxlength' => '255' ) );
	?><div class="input"><?php 
	$Form->button_input( array( 'value' => $this->T_('perform this action') ) );
	?></div><?php 
	$Form->end_form();

	// copy all widgets form
	$Form = & new Form( NULL, 'widget_manager', 'post', 'compact' );
	$Form->begin_form( 'fform', $this->T_('Copy Widgets') );
	$Form->hidden_ctrl();
	$Form->hiddens_by_key( get_memorized() );
	echo '<p>Enter the blog IDs you want to COPY widgets to.</p>';
	$Form->hidden( $this->get_class_id().'_what', 'copyto' );
	$Form->hidden( $this->get_class_id().'_which', 'all' );
	$Form->text_input( $this->get_class_id().'_copyto', '', '40', $this->T_('COPY TO'), $this->T_('Use a comma-separated list (3,8,12) or the word "All"'), array( 'maxlength' => '255' ) );
	?><div class="input"><?php 
	$Form->button_input( array( 'value' => $this->T_('perform this action') ) );
	?></div><?php 
	$Form->end_form();

	// copy all widgets in one container form ?>
	<div style="margin:1ex;border:1px dotted red;padding:1ex;background-color:aqua;">
	<strong><?php echo $this->T_('COPY one container in the master blog to any or all other blogs'); ?>:</strong>
	<?php 
	$Form = & new Form( NULL, 'widget_manager', 'post', 'compact' );
	$Form->begin_form( 'fform', $this->T_('Copy A Container') );
	$Form->hidden_ctrl();
	$Form->hiddens_by_key( get_memorized() );
	echo '<p>Enter the blog IDs you want to COPY widgets in a single container to.</p>';
	$Form->hidden( $this->get_class_id().'_what', 'copycon' );
	$Form->text_input( $this->get_class_id().'_copycon', '', '40', $this->T_('COPY TO'), $this->T_('Use a comma-separated list (3,8,12) or the word "All"'), array( 'maxlength' => '255' ) ); ?>
	<fieldset id="ffield_widgetmanager_plugin_id<?php echo $this->ID; ?>_which">
	<div class="label"><label for="widgetmanager_plugin_id<?php echo $this->ID; ?>_which">SELECT CONTAINER:</label></div>
	<div class="input">
	<select name="widgetmanager_plugin_id<?php echo $this->ID; ?>_which" id="widgetmanager_plugin_id<?php echo $this->ID; ?>_which">
	<option value="foo" selected="selected">pick one...</option>
	<?php 
	$containers_list = explode( ',', $master_containers );
	foreach( $containers_list as $a_container ) {
		echo '<option value="'.$a_container.'">'.$a_container.'</option>';
		} ?>
	</select>
	<span class="notes">whatever</span>
	</div>
	</fieldset>
	<div class="input">
	<?php 
	$Form->button_input( array( 'value' => $this->T_('perform this action') ) );
	echo '</div>';
	$Form->end_form();
	echo '</div>';

	// copy a single widget form ?>
	<div style="margin:1ex;border:1px dotted red;padding:1ex;background-color:yellow;">
	<strong><?php echo $this->T_('COPY one widget in the master blog to any or all other blogs'); ?>:</strong>
	<?php 
	$Form = & new Form( NULL, 'widget_manager', 'post', 'compact' );
	$Form->begin_form( 'fform', $this->T_('Copy A Widget') );
	$Form->hidden_ctrl();
	$Form->hiddens_by_key( get_memorized() );
	echo '<p>Enter the blog IDs you want to COPY a single widget to.</p>';
	$Form->hidden( $this->get_class_id().'_what', 'copywidg' );
	$Form->text_input( $this->get_class_id().'_copywidg', '', '40', $this->T_('COPY TO'), $this->T_('Use a comma-separated list (3,8,12) or the word "All"'), array( 'maxlength' => '255' ) ); ?>
	<fieldset id="ffield_widgetmanager_plugin_id<?php echo $this->ID; ?>_which">
	<div class="label"><label for="widgetmanager_plugin_id<?php echo $this->ID; ?>_which">SELECT WIDGET:</label></div>
	<div class="input">
	<select name="widgetmanager_plugin_id<?php echo $this->ID; ?>_which" id="widgetmanager_plugin_id<?php echo $this->ID; ?>_which">
	<option value="foo" selected="selected">pick one...</option>
	<?php 
	foreach( $master_widget_list as $a_widget ) {
		// echo '<p>'.$a_widget[0].'^'.$a_widget[1].'^'.$a_widget[2].'</p>';
		echo '<option value="'.$a_widget[0].'^'.$a_widget[1].'^'.$a_widget[2].'">'.$a_widget[0].' ('.$a_widget[2].') '.$a_widget[1].'</option>';
		} ?>
	</select>
	<span class="notes">whatever</span>
	</div>
	</fieldset>
	<div class="input">
	<?php 
	$Form->button_input( array( 'value' => $this->T_('perform this action') ) );
	echo '</div>';
	$Form->end_form();
	echo '</div>';

	// rebuild the widgets table feature
	$Form = & new Form( NULL, 'widget_manager', 'post', 'compact' );
	$Form->begin_form( 'fform', $this->T_('Rebuild Widgets table') );
	$Form->hidden_ctrl();
	$Form->hiddens_by_key( get_memorized() );
	echo '<p>This will REBUILD your entire widget table.</p>';
	$Form->hidden( $this->get_class_id().'_what', 'rebuild' );
	?><div class="input"><?php 
	$Form->button_input( array( 'value' => $this->T_('perform this action') ) );
	?></div><?php 
	$Form->end_form();

	// buy me stuff line
	echo '<p><strong>Do you need to see <a href="http://www.amazon.com/wishlist/3SS4O2KWWJ4V9?&sort=universal-price-desc" title="opens in new tab/window" target="_blank">my wishlist</a>?</strong></p>';
	}

}

?>